SystemOrganization addCategory: #'DBXTools-Descriptions'!

!DBXTable methodsFor: '*dbxtools-descriptions' stamp: 'SantiagoBragagnolo 10/29/2011 13:00'!
description
	^self class baseDescription;
			name: ( self name );
			tableName: ( self name ) ;
			relations: ( self foreignKeys collect:[ :fk | fk description ] );
			identity: ( self primary description );
			uniqueness: ( self uniques collect: [ :uk | uk description] );
			addAll: ( self columns collect:[ :col | col description ] ).


		
! !

!DBXColumnCluster methodsFor: '*dbxtools-descriptions' stamp: 'SantiagoBragagnolo 10/29/2011 12:36'!
description
	^self class baseDescription new 
		   addAll: ( self columns collect: [ : col | col description ] ).! !

!MAElementDescription methodsFor: '*dbxtools-descriptions' stamp: 'SantiagoBragagnolo 11/26/2011 19:52'!
columnName
	^self propertyAt: #columnName ! !

!MAElementDescription methodsFor: '*dbxtools-descriptions' stamp: 'GuillermoPolito 10/14/2011 02:24'!
columnName: aName
	self propertyAt: #columnName put: aName! !

!MAElementDescription methodsFor: '*dbxtools-descriptions' stamp: 'SantiagoBragagnolo 11/7/2011 11:11'!
columnType
	^DBXColumnType fromSymbolArray: (self propertyAt: #columnType).! !

!MAElementDescription methodsFor: '*dbxtools-descriptions' stamp: 'SantiagoBragagnolo 11/6/2011 15:13'!
columnType: aDBStandarTypeName
	self propertyAt: #columnType put: aDBStandarTypeName! !

!MAElementDescription methodsFor: '*dbxtools-descriptions' stamp: 'GuillermoPolito 10/29/2011 15:24'!
initializeNames: aName
	self name: aName.
	self columnName: aName.
	self instVariableName: aName.
	self accessor: aName asSymbol.! !

!MAElementDescription methodsFor: '*dbxtools-descriptions' stamp: 'GuillermoPolito 10/14/2011 02:24'!
instVariableName: aName
	self propertyAt: #instVariableName put: aName! !

!MAElementDescription methodsFor: '*dbxtools-descriptions' stamp: 'GuillermoPolito 10/14/2011 02:27'!
length: aLength
	self propertyAt: #length put: aLength! !

!MAElementDescription methodsFor: '*dbxtools-descriptions' stamp: 'GuillermoPolito 10/6/2011 03:20'!
name
	^self propertyAt: #name! !

!MAElementDescription methodsFor: '*dbxtools-descriptions' stamp: 'GuillermoPolito 11/16/2011 01:31'!
name: aName
	^self propertyAt: #name put: aName! !

!DBXColumn methodsFor: '*dbxtools-descriptions' stamp: 'SantiagoBragagnolo 11/6/2011 15:17'!
description
	| desc |
	desc :=  DBXMaTypeResolver typeFor: self type.

	desc columnType: self descriptionTuple.
	desc columnName: self name.
	desc attributeName: self name.
	desc label: self name.
	
	self nullable ifFalse: [ desc beRequired. ].
	
	^ desc.
	! !

!MARelationDescription methodsFor: '*dbxtools-descriptions' stamp: 'GuillermoPolito 11/14/2011 00:05'!
foreignColumn
	^self propertyAt: #foreignColumn! !

!MARelationDescription methodsFor: '*dbxtools-descriptions' stamp: 'GuillermoPolito 11/4/2011 14:17'!
foreignColumn: aForeignColumnName
	self propertyAt: #foreignColumn put: aForeignColumnName! !

!MARelationDescription methodsFor: '*dbxtools-descriptions' stamp: 'GuillermoPolito 11/14/2011 00:05'!
foreignKeyName
	^self propertyAt: #foreignKeyName! !

!MARelationDescription methodsFor: '*dbxtools-descriptions' stamp: 'GuillermoPolito 11/2/2011 04:36'!
foreignKeyName: aForeignKeyName
	self propertyAt: #foreignKeyName put: aForeignKeyName! !

!MARelationDescription methodsFor: '*dbxtools-descriptions' stamp: 'GuillermoPolito 11/14/2011 00:05'!
foreignTable
	^self propertyAt: #foreignTable! !

!MARelationDescription methodsFor: '*dbxtools-descriptions' stamp: 'GuillermoPolito 11/4/2011 14:16'!
foreignTable: aForeignTable
	self propertyAt: #foreignTable put: aForeignTable! !

!MARelationDescription methodsFor: '*dbxtools-descriptions' stamp: 'GuillermoPolito 11/2/2011 04:55'!
referencedClassNames
	^self propertyAt: #referencedClassNames! !

!MARelationDescription methodsFor: '*dbxtools-descriptions' stamp: 'GuillermoPolito 11/2/2011 04:43'!
referencedClassNames: anArrayOfClassNames
	self propertyAt: #referencedClassNames put: anArrayOfClassNames! !

MAVisitor subclass: #DBXGlorpMagritteVisitor
	instanceVariableNames: 'mapping glorpClassMappingBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXGlorpMagritteVisitor methodsFor: 'visiting' stamp: 'GuillermoPolito 11/6/2011 16:08'!
initialize 
	super initialize .
	mapping := DBXGlorpApplicationMapping new.! !

!DBXGlorpMagritteVisitor methodsFor: 'accessing' stamp: 'GuillermoPolito 11/6/2011 15:55'!
mapping
	^ mapping! !

!DBXGlorpMagritteVisitor methodsFor: 'visiting' stamp: 'GuillermoPolito 11/6/2011 15:28'!
visitApplication: aDBXApplication
	"Do something with the application"! !

!DBXGlorpMagritteVisitor methodsFor: 'visiting' stamp: 'GuillermoPolito 11/6/2011 16:01'!
visitDBXEntity: aDBXEntity
	glorpClassMappingBuilder ifNotNilDo: [ :elem | elem build ].
	glorpClassMappingBuilder := mapping buildClassFromEntity: aDBXEntity.! !

!DBXGlorpMagritteVisitor methodsFor: 'visiting' stamp: 'GuillermoPolito 11/6/2011 15:41'!
visitDescription: aDescription
	glorpClassMappingBuilder buildAttributeForDescription: aDescription! !

MAVisitor subclass: #DBXGlorpVisitor
	instanceVariableNames: 'visitedEntity descriptorSystem currentTable currentClass currentClassModel currentDescriptor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXGlorpVisitor class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/26/2011 19:18'!
configure: aDBXDescriptorSystem from: anApplication
	| instance |
	instance := self new.
	instance descriptorSystem: aDBXDescriptorSystem.
	anApplication acceptMagritte: (instance).
! !

!DBXGlorpVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/7/2011 12:35'!
configureDescriptor: aDescriptor with: aTable mapping: aMAElementDescription
	(aDescriptor newMapping: DirectMapping ) 
		from: (aMAElementDescription name asSymbol) 
		to: (aMAElementDescription columnName).
! !

!DBXGlorpVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/7/2011 13:23'!
configureModel: aModel hasOne: aMAToOneDescription.
	self flag:#todo. " la clase referenciada se accede asi? estupido monticello :("
	" BTW Estara bueno pensar en hacer un configureModel que en vez de ser tipado por el nombre de metodo reciba un bloque para definir el tipo de configuracin a relizar. Hay que pensarlo un poco mas. Por ahora sigo con esta idea para ver bien que es lo que se repite "
	aModel newAttributeNamed:( aMAToOneDescription name asSymbol) type: (aMAToOneDescription referencedClassNames at:0).! !

!DBXGlorpVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/7/2011 12:21'!
configureModel: aModel with: aMAElementDescription.
	aModel newAttributeNamed: aMAElementDescription name asSymbol.! !

!DBXGlorpVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/7/2011 13:21'!
configureTable: aTable hasOne:  aMAToOneDescription
	| field |
	self flag:#todo. 
	" ok, me estoy quedando sin tiempo. Aca habria que recorrer todas las relaciones columnaFrom > columnaTo y crear fields para poder usar DatabaseTable >> addForeignKeyFromAll: sourceFields toAll: targetFields.
		Por otro lado la relacion implica pedir la tabla relacionada al descriptor system. La tabla puede todavia no existir descripta dentro del descriptionSystem en ese caso (caso que siempre sucede, no importa como se recorran los entities) se ejecuta un initializeTable o algo as en el descriptorSystem (ver tableNamed:) Habria que ver como modificarlo para que encaje. (Ya que el descriptor system no conoce al visitor)
		
	"
	field := aTable createFieldNamed: aMAToOneDescription columnName 
				    type: (aMAToOneDescription columnType invokeOn: descriptorSystem platform).
	
"	aTable addForeignKeyFromAll: field to: (( descriptorSystem tableNamed: (aMAToOneDescription foreignTableName fieldNamed: aMAToOneDescription foreigName))"! !

!DBXGlorpVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/7/2011 13:06'!
configureTable: aTable with:  aMAElementDescription
	| field |
	field := aTable createFieldNamed: aMAElementDescription columnName 
				    type: (aMAElementDescription columnType invokeOn: descriptorSystem platform).
	! !

!DBXGlorpVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/6/2011 15:00'!
descriptorSystem: aDBXDescriptorSystem
	descriptorSystem := aDBXDescriptorSystem. ! !

!DBXGlorpVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/26/2011 19:19'!
visitApplication:application
	! !

!DBXGlorpVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/26/2011 19:36'!
visitDBXEntity: aDBXEntity
	visitedEntity := aDBXEntity.

	currentTable := descriptorSystem tableNamed: visitedEntity tableName.		
	self flag: #todo. " Ver que onda como loadear la clase con Dialect."
	currentClass := Smalltalk at: visitedEntity className asSymbol.

	descriptorSystem addClass: currentClass.
	currentClassModel := descriptorSystem addClassModelFor: currentClass.
	currentDescriptor := descriptorSystem addDescriptorFor: currentClass.
	
	visitedEntity attributesDo: [ :attr | attr acceptMagritte: self ].
	
	currentTable postInitializeIn: descriptorSystem.! !

!DBXGlorpVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/7/2011 12:33'!
visitElementDescription: aMAElementDescription
	"Aca solo llegan las definiciones simples, belongsTo, oneToOne, oneToMany, manyToMany tienen sus respectivos 'visit' '"
	self configureTable: currentTable with: aMAElementDescription.
	self configureModel: currentTable with: aMAElementDescription.
	self configureDescriptor: currentDescriptor with: currentTable mapping: aMAElementDescription.
	
! !

!DBXGlorpVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/6/2011 14:54'!
visitPriorityContainer: aMAPriorityContainer
	"Nothing"! !

!DBXGlorpVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/7/2011 12:55'!
visitToManyRelationDescription: aMAToOneRelationDescription! !

!DBXGlorpVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/7/2011 12:55'!
visitToOneRelationDescription: aMAToOneRelationDescription! !

MAVisitor subclass: #DBXMagritteClassBuilderVisitor
	instanceVariableNames: 'mustBuildAccessors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXMagritteClassBuilderVisitor methodsFor: 'building' stamp: 'GuillermoPolito 10/6/2011 04:09'!
buildAccessorForAttribute: attribute inClass: aClass
	"getter"
	aClass compile: ('{1}
		^{1}' format: {attribute name}).
	"setter"
	aClass compile: ('{1}: {2}
		{1} := {2}' format: {attribute name .  (attribute name first isVowel ifTrue: ['an'] ifFalse: ['a']), attribute name capitalized })! !

!DBXMagritteClassBuilderVisitor methodsFor: 'building' stamp: 'GuillermoPolito 10/6/2011 04:56'!
buildAccessorsFor: aDBXEntity
	aDBXEntity attributesDo: [ :attribute |
			self buildAccessorForAttribute: attribute inClass: (Smalltalk globals at: aDBXEntity dbxClassName asSymbol)
		]! !

!DBXMagritteClassBuilderVisitor methodsFor: 'building' stamp: 'GuillermoPolito 10/6/2011 04:37'!
buildInstVarStringFromEntity: aDBXEntity
	^' ' join: (aDBXEntity attributes collect: #name)! !

!DBXMagritteClassBuilderVisitor methodsFor: 'initialize-release' stamp: 'GuillermoPolito 10/6/2011 04:10'!
initialize
	mustBuildAccessors := false! !

!DBXMagritteClassBuilderVisitor methodsFor: 'configuring' stamp: 'GuillermoPolito 10/6/2011 04:03'!
mustBuildAccessors: aBoolean
	mustBuildAccessors := aBoolean! !

!DBXMagritteClassBuilderVisitor methodsFor: 'visiting' stamp: 'GuillermoPolito 11/4/2011 16:00'!
visitApplication: aDBXApplication 
	"nothing by now"! !

!DBXMagritteClassBuilderVisitor methodsFor: 'visiting' stamp: 'GuillermoPolito 11/4/2011 16:59'!
visitDBXEntity: aDBXEntity 

	| instVarString |
	
	instVarString := self buildInstVarStringFromEntity: aDBXEntity.
	
	Object subclass: aDBXEntity dbxClassName capitalized asSymbol
		instanceVariableNames: instVarString
		classVariableNames: ''
		poolDictionaries: ''
		category: aDBXEntity category.
	
	mustBuildAccessors ifTrue: [ self buildAccessorsFor: aDBXEntity ]
		! !

MAVisitor subclass: #DBXMagritteWriterVisitor
	instanceVariableNames: 'visitedEntity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXMagritteWriterVisitor methodsFor: 'visiting' stamp: 'GuillermoPolito 11/4/2011 17:00'!
visitApplication: aDBXApplication 
	"nothing by now"! !

!DBXMagritteWriterVisitor methodsFor: 'visiting' stamp: 'GuillermoPolito 11/6/2011 15:32'!
visitDBXEntity: aDBXEntity
	visitedEntity := aDBXEntity.! !

!DBXMagritteWriterVisitor methodsFor: 'visiting' stamp: 'GuillermoPolito 10/8/2011 16:44'!
visitElementDescription: aMAElementDescription
	self writeDescription: aMAElementDescription onClass: (self class environment at: visitedEntity dbxClassName asSymbol) class! !

!DBXMagritteWriterVisitor methodsFor: 'visiting' stamp: 'GuillermoPolito 10/6/2011 04:34'!
visitPriorityContainer: aMAPriorityContainer
	"Nothing"! !

!DBXMagritteWriterVisitor methodsFor: 'writing' stamp: 'GuillermoPolito 11/5/2011 06:10'!
writeDescription: aMADescription onClass: aClass
	| properties descriptionMethod classes |
	properties := ';
		' join: (aMADescription 
		properties 
		associations 
		collect: [ :assoc | '{1}: {2}' format: {assoc key . assoc value printString}]).

	(aMADescription isKindOf: MARelationDescription)
	ifTrue: [ classes := 'classes: ', aMADescription classes printString, ';' ]
	ifFalse: [ classes := '' ].

	descriptionMethod := 'description{1}
	^{2} new
		accessor: {3};
		{4}
		{5};
		yourself. ' 
		format: { aMADescription name capitalized. 
			aMADescription class name.
			aMADescription accessor readSelector printString.
			classes.
			properties }.
	aClass compile: descriptionMethod classified: 'dbxDescriptions'.! !

!MAVisitor methodsFor: '*dbxtools-descriptions' stamp: 'SantiagoBragagnolo 10/22/2011 21:05'!
visitEntityRelationDescription: anObject
	self visitElementDescription: anObject! !

MAContainer subclass: #DBXApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXApplication class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 15:39'!
fromTables: someTables
	^self new
		addAll: (someTables 
			collect: [ :table | (DBXDescriptionFromTableBuilder forTable: table) 
								generateMagritteDescription  ] );
		yourself! !

!DBXApplication class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 15:43'!
fromTables: someTables defaultCategory: aCategory
	^self new
		addAll: (someTables 
			collect: [ :table | (DBXDescriptionFromTableBuilder forTable: table) 
								inCategory: aCategory;
								generateMagritteDescription  ] );
		yourself! !

!DBXApplication methodsFor: 'visiting' stamp: 'GuillermoPolito 10/6/2011 04:15'!
acceptMagritte: aVisitor
	aVisitor visitApplication: self.
	self do: [ :entity | entity acceptMagritte: aVisitor ]! !

MAContainer subclass: #DBXEntity
	instanceVariableNames: 'attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXEntity commentStamp: 'GuillermoPolito 11/4/2011 14:42' prior: 0!
I describe a concept of an application.  I'm mented to be used to build classes, tables, write magritte descriptions, glorp mappings...!

!DBXEntity methodsFor: 'comparing' stamp: 'GuillermoPolito 11/2/2011 02:58'!
= anEntity
	^self class = anEntity class and: [ self attributes = anEntity attributes ]! !

!DBXEntity methodsFor: 'magritte' stamp: 'GuillermoPolito 11/6/2011 15:32'!
acceptMagritte: aVisitor
	aVisitor visitDBXEntity: self.
	self attributes do: [ :attr | aVisitor visit: attr ]! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/6/2011 04:36'!
addAttribute: anAttribute
	 attributes add: anAttribute! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/6/2011 04:35'!
attributes
	^attributes! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/6/2011 04:35'!
attributesDo: anAction
	self attributes do: anAction! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/4/2011 15:17'!
category
	^ self propertyAt: #category! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/4/2011 15:17'!
category: aCategory
	^ self propertyAt: #category put: aCategory! !

!DBXEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/7/2011 11:29'!
className
	^self propertyAt: #className.! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/14/2011 02:18'!
className: aName
	self propertyAt: #className put: aName! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/4/2011 15:07'!
dbxClassName
	^ self propertyAt: #className ifAbsent: [ self defaultName ]! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/4/2011 15:08'!
dbxClassName: aClassName
	^ self propertyAt: #className put: aClassName! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/4/2011 15:08'!
defaultName
	^ self propertyAt: #defaultName! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/4/2011 15:08'!
defaultName: aName
	^ self propertyAt: #defaultName put: aName! !

!DBXEntity methodsFor: 'comparing' stamp: 'GuillermoPolito 11/2/2011 02:58'!
hash
	^self attributes hash! !

!DBXEntity methodsFor: 'initialize-release' stamp: 'GuillermoPolito 10/6/2011 04:36'!
initialize 
	attributes := Set new! !

!DBXEntity methodsFor: 'initialization' stamp: 'GuillermoPolito 11/4/2011 17:01'!
initializeNames: aName
	self name: aName.
	self className: aName capitalized.
	self tableName: aName.! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 11/2/2011 02:53'!
name
	^self propertyAt: #name! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/14/2011 02:17'!
name: aName
	self propertyAt: #name put: aName! !

!DBXEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/7/2011 11:28'!
tableName
	self flag: #todo. "una entity tendria que tener varias tablas relacionadas"
	^self propertyAt: #tableName.! !

!DBXEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/7/2011 11:28'!
tableName: aName
	self flag: #todo. "una entity tendria que tener varias tablas relacionadas"
	self propertyAt: #tableName put: aName! !

DescriptorSystem subclass: #DBXDescriptorSystem
	instanceVariableNames: 'tableNames classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXDescriptorSystem class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/6/2011 14:46'!
for: anApplication
	| instance | 
	instance := self new. 
	DBXGlorpVisitor configure: instance from: anApplication.
	^instance.! !

!DBXDescriptorSystem methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/7/2011 11:24'!
addClass: aClass
	self allClasses add: aClass.! !

!DBXDescriptorSystem methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/7/2011 11:42'!
addDescriptorFor: aClass
	| aDescriptor |
	aDescriptor := self newDescriptorFor: aClass.
	descriptors at: aClass put: aDescriptor.
	^ aDescriptor.! !

!DBXDescriptorSystem methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/6/2011 12:14'!
allTableNames 
	^ tableNames.
	
! !

!DBXDescriptorSystem methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/26/2011 19:47'!
classes
	classes ifNil:[ classes := OrderedCollection new ].
	^classes! !

!DBXDescriptorSystem methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/26/2011 19:45'!
constructAllClasses 
	^ super constructAllClasses addAll: self classes; yourself.! !

!DBXDescriptorSystem methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/6/2011 13:10'!
constructAllTables
	^ tables.! !

!DBXDescriptorSystem methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/26/2011 19:33'!
initializeTable: newTable
	| initializerName |
	initializerName := ('tableFor' , (newTable name asUppercase) , ':') asSymbol.
	(self respondsTo: initializerName)
		ifTrue: [self perform: initializerName with: newTable].! !

!DBXDescriptorSystem methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/26/2011 19:38'!
tableNamed: aString ifNone: aBlock
	^tables at: aString asString asUppercase ifAbsent: [
		| newTable|
		newTable := DatabaseTable new.
		newTable name: aString.
		tables at: aString asUppercase put: newTable.
		self initializeTable: newTable.
		newTable].! !

Object subclass: #DBXDescriptionFromTableBuilder
	instanceVariableNames: 'table category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXDescriptionFromTableBuilder class methodsFor: 'instance creation' stamp: 'GuillermoPolito 10/14/2011 02:08'!
forTable: aTable
	^self new table: aTable; yourself! !

!DBXDescriptionFromTableBuilder methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/2/2011 04:50'!
attributeToMagritteResolverFor: aColumn
	^(table isForeignKey: aColumn) 
		ifFalse: [ DBXSimpleAttributeMagritteResolver new column: aColumn; yourself ]
		ifTrue: [ DBXRelationAttributeMagritteResolver column: aColumn table: table ]! !

!DBXDescriptionFromTableBuilder methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 15:44'!
category
	^category! !

!DBXDescriptionFromTableBuilder methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/2/2011 02:55'!
dbxAttributeFromColumn: aColumn
	^(self attributeToMagritteResolverFor: aColumn) buildMagritteElementDescription! !

!DBXDescriptionFromTableBuilder methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 15:44'!
generateMagritteDescription
	| entity |
	entity := DBXEntity new.
	entity initializeNames: table name.
	table columnsDo: [ :column | entity addAttribute: (self dbxAttributeFromColumn: column)].
	entity category: self category.
	^entity! !

!DBXDescriptionFromTableBuilder methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 15:44'!
inCategory: aCategory
	category := aCategory! !

!DBXDescriptionFromTableBuilder methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 10/14/2011 02:07'!
table: aTable
	table := aTable.! !

Object subclass: #DBXGlorpApplicationMapping
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXGlorpApplicationMapping methodsFor: 'building' stamp: 'GuillermoPolito 11/6/2011 15:50'!
buildClassFromEntity: aDBXEntity 
	^DBXGlorpClassMapping application: self entity: aDBXEntity.! !

Object subclass: #DBXGlorpClassMapping
	instanceVariableNames: 'attributes entity application'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXGlorpClassMapping class methodsFor: 'instance creation' stamp: 'GuillermoPolito 11/6/2011 15:51'!
application: aDBXGlorpApplicationMapping entity: aDBXEntity 
	^self new
		application: aDBXGlorpApplicationMapping;
		entity: aDBXEntity;
		yourself! !

!DBXGlorpClassMapping methodsFor: 'accessing' stamp: 'GuillermoPolito 11/6/2011 16:05'!
application: aDBXGlorpApplicationMapping 
	application := aDBXGlorpApplicationMapping! !

!DBXGlorpClassMapping methodsFor: 'building' stamp: 'GuillermoPolito 11/6/2011 16:09'!
build
	"nothing by now"! !

!DBXGlorpClassMapping methodsFor: 'building' stamp: 'GuillermoPolito 11/6/2011 15:53'!
buildAttributeForDescription: aDBXAttribute
	attributes add: aDBXAttribute! !

!DBXGlorpClassMapping methodsFor: 'accessing' stamp: 'GuillermoPolito 11/6/2011 16:05'!
entity: aDBXEntity
	entity := aDBXEntity! !

!DBXGlorpClassMapping methodsFor: 'building' stamp: 'GuillermoPolito 11/6/2011 16:05'!
initialize
	attributes := Set new! !

Object subclass: #DBXMaTypeResolver
	instanceVariableNames: 'types'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXMaTypeResolver commentStamp: 'SantiagoBragagnolo 10/29/2011 13:27' prior: 0!
DBXMaTypeResolver is an object which recives database types as messages and return a MADescription associated type. 

| ie | 
ie := DBXMaTypeResolver new. 
ie varchar
ie varchar:30
ie int2
ie integer

!

!DBXMaTypeResolver class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 15:56'!
typeFor: aColumnType
	^aColumnType invokeOn: self new.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:52'!
blob
	self flag: #todo. " ver que descripcion usar con  blob!!"
	^(self typeNamed: #blob ifAbsentPut: [self error:'No hay un tipo magritte asociado!!'  ]) new.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 16:30'!
boolean
	^(self typeNamed: #boolean ifAbsentPut: [ MABooleanDescription ]) new.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 16:30'!
char
	^(self typeNamed: #char ifAbsentPut: [ MAStringDescription ]) new.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 16:30'!
character
	^self char! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:52'!
clob
	self flag: #todo. " ver que descripcion usar con  clob!!"
	^(self typeNamed: #clob ifAbsentPut: [self error:'No hay un tipo magritte asociado!!'  ]) new.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 16:33'!
date
	^(self typeNamed: #date ifAbsentPut: [ MADateDescription  ]) new.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 16:32'!
datetime
	^(self typeNamed: #datetime ifAbsentPut: [ MADateAndTimeDescription ]) new.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:50'!
double
	^self number.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:50'!
int
	^self number.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:50'!
int2
	^self number.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:50'!
int4
	^self number.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:50'!
int8
	^self number.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:51'!
integer
	^self number.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:50'!
number
	^(self typeNamed: #number ifAbsentPut: [ MANumberDescription ]) new.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:51'!
numeric
	^self number.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:51'!
nvarchar
	^self char.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:59'!
raw
	self flag: #todo. " ver que descripcion usar con  raw!!"
	^(self typeNamed: #raw ifAbsentPut: [ self error:'No hay un tipo magritte asociado!!' ]) new.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:53'!
sequence
	^ self serial.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:53'!
serial
	^ self number.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:53'!
smallint
	^ self number.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:53'!
text
	^ self char.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:53'!
time
	^(self typeNamed: #time ifAbsentPut: [ MATimeDescription  ]) new.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:54'!
timestamp
	^(self typeNamed: #timestamp ifAbsentPut: [ MATimeStampDescription ]) new.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:54'!
typeNamed: aSymbol ifAbsentPut: aBlock
	^self types at: aSymbol ifAbsentPut: [aBlock value ] .
	! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:55'!
types 
	types ifNil: [ types := IdentityDictionary new ].
	^ types.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:56'!
varChar
	^ self char! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:57'!
varChar: aLength
	| desc | 
	desc := self varChar.
	desc length:aLength.
	^desc.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:59'!
varbinary
	self flag: #todo. " ver que descripcion usar con  varbinary!!"
	^(self typeNamed: #varbinary ifAbsentPut: [self error:'No hay un tipo magritte asociado!!'  ]) new.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:58'!
varbinary: aLength
	| desc | 
	desc := self varbinary.
	desc length:aLength.
	^desc.! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:56'!
varchar
	^ self char! !

!DBXMaTypeResolver methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/22/2011 12:57'!
varchar: aLength
	| desc | 
	desc := self varchar.
	desc length:aLength.
	^desc.! !

Object subclass: #DBXRelationAttributeMagritteResolver
	instanceVariableNames: 'column foreignKey table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXRelationAttributeMagritteResolver class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/2/2011 04:50'!
column: aColumn table: aTable
	^self new column: aColumn; table: aTable; yourself! !

!DBXRelationAttributeMagritteResolver methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/6/2011 15:18'!
buildMagritteElementDescription 
	| magritteDescriptionClass description className |
	description := MAToOneRelationDescription new.
	description initializeNames: column name.
	description foreignKeyName: self foreignKey name.
	description foreignColumn: (self foreignKey foreignColumnForColumn: column).
	description foreignTable: self foreignKey foreignTableName.
	className := self foreignKey foreignTableName capitalized asSymbol.
	description classes: (self class compilerClass evaluate: ('[ Smalltalk at: {1} ].' format: { className printString })).
	^description! !

!DBXRelationAttributeMagritteResolver methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/2/2011 04:19'!
column: aColumn
	column := aColumn! !

!DBXRelationAttributeMagritteResolver methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/2/2011 04:51'!
foreignKey
	^table foreignKeyForColumn: column! !

!DBXRelationAttributeMagritteResolver methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/2/2011 04:51'!
table: aTable
	table := aTable! !

Object subclass: #DBXSimpleAttributeMagritteResolver
	instanceVariableNames: 'column'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXSimpleAttributeMagritteResolver methodsFor: 'magritte-building' stamp: 'GuillermoPolito 11/4/2011 15:56'!
buildMagritteElementDescription 
	| magritteDescriptionClass description |
	description := self magritteTypeForColumn: column.
	description initializeNames: column name.
	column nullable ifFalse: [ description beRequired ].
	column length ifNotNilDo: [ :length | description length: length ].
	^description! !

!DBXSimpleAttributeMagritteResolver methodsFor: 'accessing' stamp: 'GuillermoPolito 10/8/2011 17:33'!
column: aColumn
	column := aColumn! !

!DBXSimpleAttributeMagritteResolver methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 11/4/2011 15:50'!
magritteTypeForColumn: aColumn
	^DBXMaTypeResolver typeFor: aColumn type! !

!DBXForeignKey methodsFor: '*dbxtools-descriptions' stamp: 'SantiagoBragagnolo 10/22/2011 20:25'!
description 
	| desc |
	desc :=  self class baseDescription.
	desc reference: [ :applicationContext | applicationContext entityRelatedTo: self reference].
	desc ! !
